#ifndef ABSOLUTE_DUAL_QUADRIC_H
#define ABSOLUTE_DUAL_QUADRIC_H

// library includings
#include "num_linalg.h"

// own includings
#include "MatrixOperations.h"
#include "Func.h"
#include "SolveEq.h"

namespace Basics3D
{
	class AbsoluteDualQuadric
	{
	private:
		void CreateSystem(Vtl::NumAlg::Lin::ublas::c_matrix<double, 8, 10> &out_s,
			                const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P,
			                const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P1);

		int SolveDet0(Vtl::NumAlg::Lin::ublas::c_matrix<double, 4, 16> &out_Q,
			             const Vtl::NumAlg::Lin::ublas::c_matrix<double, 8, 10> &in_s);

	public:
		int Get(Vtl::NumAlg::Lin::ublas::c_matrix<double, 4, 16> &out_Q,
			       const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P,
				     const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P1);
	};
}

#endif // ABSOLUTE_DUAL_QUADRIC_H
