#ifndef AUTO_CALIBRATION_H
#define AUTO_CALIBRATION_H

#include <iostream>

// library includings
#include "num_linalg.h"

// own includings
#include "RQDecomposition.h"
#include "MatrixOperations.h"
#include "EssentialMatrix.h"
#include "AbsoluteDualQuadric.h"
#include "EigenValueDecomp.h"
#include "ProjectiveMatrix.h"
#include "Sort.h"

namespace Basics3D
{
	class C_AutoCalibration
	{
	private:
		// Computes focal length (common for both images) with Kruppa equations
		// !was not used, not debuged
		void FocalLength(double out_f1[2],
			               double out_f2[2],
			               const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_F);

		double DirectSearchOfFocalLenth
			                     (const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_F);
	public:
		// !was not used, not debuged
		void DecomposeProjMatr(Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out_K,
			                     Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out_R,
	                         Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &out_t,
			                     const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P);
	
		int GetH(std::vector<Vtl::NumAlg::Lin::ublas::c_matrix<double, 4, 4>> &out_H,
			        const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P,
			        const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P1);

		void GetRightP(std::vector<Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4>> &out_P,
			             Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out_K,
			             Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out_K1,
										Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out_E,
									 const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_F);
	};
}


#endif //AUTO_CALIBRATION_H
