
#include "Epipole.h"

namespace Basics3D
{
	void C_Epipole::Left(Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &out_e,
			                 const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_Matrix)
	{
		SolveSystem(out_e, in_Matrix);
		
		for (int i = 0; i < 3; i++)
		{
		  out_e(i) /= out_e(2);
		}
	}

	///////////////////////////////////////////////////////////////////////////////////////
	void C_Epipole::Right(Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &out_e,
			                  const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_Matrix)
	{
	  Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> F = 
			                                           boost::numeric::ublas::trans(in_Matrix);
		Left(out_e, F);
	}

	///////////////////////////////////////////////////////////////////////////////////////
	void C_Epipole::Normalize(Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &in_out)
	{
		double d = sqrt(in_out(0) * in_out(0) + in_out(1) * in_out(1));

		in_out(0) /= d;
		in_out(1) /= d;
		in_out(2) /= d;
	}
}