#ifndef FINC_WITH_DER_H
#define FINC_WITH_DER_H

namespace Basics3D
{
	class IFunc
	{
	public:
		virtual double Func(const double in_t) const = 0;
	};

	/////////////////////////////////////////////////////////////////////////////////////////
	class IFuncWithDer: public IFunc
	{
	public:
		virtual double Deriv(const double in_t) const = 0;
	};

	/////////////////////////////////////////////////////////////////////////////////////////
	class g: public IFuncWithDer
	{
	private:
		const double a;      // parameters
		const double b;      //     
		const double c;      //             of
		const double d;      //                 the
		const double f;      //                      
		const double f1;     //                      function
		const int n;         // max number of roots

	public:
		g(const double in_a,
			const double in_b,
			const double in_c,
			const double in_d,
			const double in_f,
			const double in_f1,
			const int in_n);

		double Func(const double in_t) const;
		double Deriv(const double in_t) const;
		int N();
	};

	/////////////////////////////////////////////////////////////////////////////////////////
	class test: public IFuncWithDer
	{
	private:
		const double a;
		const double b;

	public:
		test(const double in_a,
				 const double in_b);

		double Func(const double in_t) const;
		double Deriv(const double in_t) const;
	};

	///////////////////////////////////////////////////////////////////////////////////////
	class Eq4Degree: public IFuncWithDer
	{
	private:
		const double m_a;
		const double m_b;
		const double m_c;
		const double m_d;
		const double m_e;
		const int m_n;

	public:
		Eq4Degree(const double in_a,
			        const double in_b,
							const double in_c,
							const double in_d,
							const double in_e,
							const int in_n);

		int N() const;

		double Func(const double in_t) const;
		double Deriv(const double in_t) const;
	};
}
#endif // FINC_WITH_DER_H
