#ifndef INCLUDINGS_H
#define INCLUDINGS_H

#include <iostream>
#include <math.h>

//library includings
#include "num_linalg.h"

// own includings
#include "MatrixOperations.h"
#include "Combination.h"
#include "Point2D.h"
#include "Points2DSet.h"
#include "Points2DParamSet.h"
#include "HomographyMatrix.h"
#include "FundamentalMatrix.h"
#include "TransformMatrices.h"
#include "Transform.h"
#include "AbsDifference.h"
#include "Ransac.h"
#include "Model.h"
#include "RecompMatrix.h"
#include "DrawEpipolarLines.h"
#include "MistakeFunc.h"
#include "DFPMinimization.h"
#include "ImagesSet.h"
#include "StructureComputation.h"

namespace Basics3D
{
	typedef Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> matrix_3_3;

	void LoadPoints(std::vector<C_Points2DParamSet> &out_PointsParamSet,
		              std::vector<T_Points2DSet<C_Point2D>> &out_PointsSet,
                  char *in_argv[],
									const int in_N,
									const double in_T,
									const int in_imHeight);

	void MarkCorrespondences(const char *in_name,
		                       const int j,  // addition to name
		                       const T_ImagesSet<AImageMem8> &in_img,
		                       const std::vector<T_Points2DSet<C_Point2D>> &in_PointsSet,
													 const int i); // number of points to mark
													               // -1 means all points

	void MarkCorrespondences(const char *in_name,
		                       const T_ImagesSet<AImageMem8> &in_img,
		                       const T_Points2DSet<C_Point2D> &in_PointsSet,
													 const int N,
													 const int i);

	void MakeDifferenceImage(const T_ImagesSet<AImageMem8> &in_img,
		                       const std::vector<matrix_3_3> &in_Matrix,
		                       const int i,
					                 const int j,
					                 const int k);

	void DrawEpipolarLines(const T_ImagesSet<AImageMem8> &in_img,
		                     const matrix_3_3 &in_Matrix,
						             const std::vector<T_Points2DSet<C_Point2D>> &in_PointsSet,
						             const int i,
						             const int n);

	void FindCommonFeaturePoints(T_Points2DSet<C_Point2D> &out_commonPoints,
		                           const std::vector<T_Points2DSet<C_Point2D>> &in_Inliers,
		                           const int N);

	int Test(int argc, char *argv[]);
}
#endif //INCLUDINGS_H
