
#include "SolveEq.h"

namespace Basics3D
{
	int SolveEq::Find(std::vector<double> &out_sol,
						        const IFuncWithDer *in_g,
										double *io_x1,
										double *io_x2,
										int *io_k,
						        const double in_acc)
	{
		// bracket the root
		try
		{
			zbrac(in_g, io_x1, io_x2);
		}
		catch(char *msg)
		{
			std::cout << std::endl << msg;
			return 0;
		}                                            ///*temp*/std::cout << std::endl << "after bracketing x1 = "
																									///*temp*/<< *io_x1<< "  x2 = " << *io_x2;
			                                           
		double s;
		try
		{
			// find the root
			s = rtsafe(in_g, *io_x1, *io_x2, in_acc);
			                                           ///*temp*/std::cout << std::endl << " s = " << s;
			// check if the root has been found before
			int exs = 0;
			for (int i = 0; i < *io_k; i++)
			{                                          ///*temp*/std::cout << std::endl << "check: sol[" << i << "] = " << out_sol[i] << "  " << s - out_sol[i];
				if (fabs(s - out_sol[i]) < in_acc)
				{                                        ///*temp*/std::cout << "  !!!";
					exs = 1;
					break;
				}
			}                                          ///*temp*/	std::cout << std::endl << " exs = " << exs;

			// if the root is new
			if (!exs)
			{
				//std::cout << std::endl << ":)";
				out_sol[*io_k] = s;
				//std::cout << "  k = " << (*io_k);
				(*io_k)++;
				//std::cout << "  k = " << (*io_k);
				return 1;
			}
			else
			{
				return 0;
			}
		}
		catch(char *msg)
		{
			std::cout << std::endl << msg;
			return 0;
		}
	}

	///////////////////////////////////////////////////////////////////////////////////////
	int SolveEq::Apply(std::vector<double> &out_sol,
							       const IFuncWithDer *in_g,
							       const double in_acc)
	{
		double step_l = in_acc;
		double step_r = in_acc;
		double xm = 0.0;
		double xl = 0.0;
		double xr = 0.0;
		int k = 0;
		int size = (int)out_sol.size();              ///*temp*/int c = 0;
		
		while (k < size)
		{    
			//if ( k == 2)
			//{
			//	std::cout << "";
			//}///*temp*/c++;
			xm = xl;
			xl = xm - step_l;                          ///*temp*/std::cout << std::endl << " xl = " << xl
																								 ///*temp*/<< "  xm = " << xm << "  step_l = "
																								 ///*temp*/<< step_l << " k = " << k;
			if (!Find(out_sol, in_g, &xl, &xm, &k, in_acc))
			{
				//std::cout << std::endl << ":(";
				step_l *= 2.0;
			}  
			//else
			//{
			//	std::cout << std::endl << "!!!";
			//}																					 /*temp*/std::cout << std::endl << " xl = " << xl
			//																					 /*temp*/<< "  xm = " << xm << "  step_l = "
			//																					 /*temp*/<< step_l << " k = " << k;
			//std::cout << std::endl << "___________________________________________";
			
			xm = xr;
			xr = xm + step_r;                          ///*temp*/std::cout << std::endl << " xm = " << xm
																								 ///*temp*/<< "  xr = " << xr << "  step_r = "
																								 ///*temp*/<< step_r << " k = " << k;			
			if (!Find(out_sol, in_g, &xm, &xr, &k, in_acc))
			{
				//std::cout << std::endl << ":(";
				step_r *= 2.0;
			}
			//else
			//{
			//	std::cout << std::endl << "!!!";
			//}																					 /*temp*/std::cout << std::endl << " xm = " << xm
			//																					 /*temp*/<< "  xr = " << xr << "  step_r = "
			//																					 /*temp*/<< step_r << " k = " << k;			
			//std::cout << std::endl << "===========================================";

			if (xl < -MAX || xr > MAX)
			{
				break;
			}
		}																			       ///*temp*/	std::cout << std::endl << "c = " << c << std ::endl;
																								 ///*temp*/for (int i = 0; i < k; i++) std::cout << out_sol[i] << "  ";
	  return k;
	}
}