#ifndef RAYLEIGH_EDGE_VALUE_H
#define RAYLEIGH_EDGE_VALUE_H

// system includings
#include <memory> 

// library includings
#include "imalg_tools.h"
#include "plf_functors.h"

// own includings
#include "EdgeDetection/GradientOperations.h"

///////////////////////////////////////////////////////////////////////////////
/*namespace Vtl
{
namespace Plf
{
namespace Fpie
{
  template<typename T> 
	class RayleighNMS
	{
	private:
		T thr;
		int nls;

	public:
		void set_IterNextLineShift(int modul_nls)
		{ 
			nls = modul_nls;
		}

		//=========================================================================
		Extent ext() const 
		{
			return Extent(1, 1, 1, 1);
		}

		//=========================================================================
		RayleighNMS() {nls=0x5FFFFFFF;}
		RayleighNMS(T threshold):thr(threshold) {nls=0x5FFFFFFF;}
		T operator()(const T* modul,T gx,T gy, T* mean, T* disp)
		{
			if(modul[0]>=thr)
			{
				T v1;
				T v2;
				if(ABS(gx) < ABS(gy))
				{//     .   -    
					T alpha=gx/gy;
					if(alpha<0)
					{// (gx< gy) && ((gx<0 gy >0 )|| (gx>0 gy < 0 ) ) 
						//    , '+' -  , 
						// alpha=0 -  (|) , alpha=1 -  (/)
						//
						//    +-+=+ 
						//    | | |
						//    +-+-+ 
						//    | | |
						//    +=+-+ 
						//
						v1=(1+alpha)*modul[-nls]-alpha*modul[-nls+1];
						v2=(1+alpha)*modul[+nls]-alpha*modul[+nls-1];
					}
					else
					{// (gx< gy) && ( (gx>=0 gy >0) || ( gx<=0 gy < 0 ) ) 
						//    , '+' -  , 
						// alpha=0 -  (|) , alpha=1 -  (\)
						//
						//    +=+-+ 
						//    | | |
						//    +-+-+ 
						//    | | |
						//    +-+=+ 
						//
						v1=(1-alpha)*modul[-nls]+alpha*modul[-nls-1];
						v2=(1-alpha)*modul[+nls]+alpha*modul[+nls+1];
					}
				}
				else
				{//     .  -    
					T alpha=gy/gx;
					if(alpha<0)
					{// (gx >= gy) && ( (gx>0 , gy<=0) || ( gx <0 gy >= 0 ) ) 
						//   (#)  , '+' -  , 
						// alpha=0 -  (-) , alpha=1 -  (/)
						//
						//
						//    +-+-+ 
						//    | | #
						//    +-+-+ 
						//    # | |
						//    +-+-+ 
						//
						v1=(1+alpha)*modul[-1]-alpha*modul[-1+nls];
						v2=(1+alpha)*modul[+1]-alpha*modul[+1-nls];
					}
					else
					{// (gx >= gy) && ( (gx>0 , gy>=0) || ( gx <0 gy <= 0 ) ) 
						//   (#)  , '+' -  , 
						// alpha=0 -  (-) , alpha=1 -  (\)
						//
						//    +-+-+ 
						//    # | |
						//    +-+-+ 
						//    | | #
						//    +-+-+ 
						//
						v1=(1-alpha)*modul[-1]+alpha*modul[-1-nls];
						v2=(1-alpha)*modul[+1]+alpha*modul[+1+nls];
					}
				}
				T v0=modul[0];
				if( (v0 >= v1) && (v0 >= v2) )
					return v0;
			}
			return 0;
		}
	};
}
}
}*/


/////////////////////////////////////////////////////////////////////////////
/*template< typename T >
class RayleighEdgeValue
{
public:
	std::vector<T> edgeStrength;
	//std::vector<T> edgeStrength;
	//std::vector<T> edgeStrength;

private:
  T* edges;
  T* srcImg;
  T* dst;
  T sigma;

  //===========================================================================
public:
	Apply(T* src,
			  T* dst,
			  int w,
			  int h,
			  T sigma,
			  T nSigmasEnv)
	{
	  int size = w * h;
		T smSigma = sigma / 2;

		// mean
		std::vector<T> mean(size);
		memcpy(&(mean[0]), &(src[0]), size * sizeof(T));

		typedef Vtl::ImAlg::WndFun::Gauss<float, 0, false> FF0; 
		FF0 f0(smSigma, nSigmasEnv);
		typedef Vtl::Plf::Kernel::FKern<float, Vtl::Plf::Kernel::KT_Conv, true> K0;
		K0 ker0(f0);
		Vtl::ImAlg::Conv::ConvInplace<float, K0> g0(ker0);

		Vtl::ImAlg::Conv::Conv2D::conv2DInplace(&(mean[0]), w, h, nls, g0_bg, g0_bg);

		// sqrt of mean
		std::vector<T> sqrOfMean(size);
		Vtl::Plf::F11::Sqr<T> sqr;
		Vtl::ImAlg::Tools::copy_1_1(&(sqrOfMean[0]), w, h, nls, &(mean[0]), nls, sqr);

		// sqr of input
		std::vector<T> meanOfSqr(size);
		Vtl::ImAlg::Tools::copy_1_1(&(meanOfSqr[0]), w, h, nls, &(srcImg[0]), nls, sqr);

		// mean of sqr
		Vtl::ImAlg::Conv::Conv2D::conv2DInplace(&(meanOfSqr[0]), w, h, nls, g0_bg, g0_bg);

		// dispersion
		std::vector<T> disp(size);
		Vtl::Plf::F21::Dif<T> dif;
		Vtl::ImAlg::Tools::copy_2_1(&(meanOfSqr[0]), w, h, nls, &(sqrOfMean[0]), nls,
																													 &(disp[0]), nls, dif);
		// Gradient
		std::vector<T> gradMod(size);
		std::vector<T> Lx(size);
		std::vector<T> Ly(size);
		Gradient(&(gradMod[0]), &(Lx[0]), &(Ly[0]), &(src[0]), w, h, sigma, nSigmasEnv);

		// Non maxima supression with calculation Rayleigh edge strength
	}

};
template< typename T >
void RayleighEdgeDetector(T* src,
												  T* dst,
												  int w,
												  int h,
												  T sigma,
												  T nSigmasEnv)
{
  

}*/

#endif RAILEIGH_EDGE_VALUE_H