// system includings
//#include <memory> 
#include <vector>
#include <iostream>

// library includings
#include "aimage.h"
#include "consolap.h"
//#include "imalg_tools.h"
//#include "plf_functors.h"

// own includings
//#include "EdgeDetection/CannyEdgeDetector.h"
#include "SaveImageArray.h"
//#include "ImgFromGrad.h"
//#include "StatDiff.h"
#include "EdgeDetection/DiZenzoEdgeDetector.h"


namespace Tests
{
  int TestDiZenzo(int argc, char *argv[])
  {
    // Load input image
    if(argc < 2) 
    {
		  std::cout << "Argument - input image" << std::endl;
      return 0;
    }

    const char *fname = argv[1];
	  std::auto_ptr<AImage> _img(::AImageLoad(0, true, fname, indicator));
    AImageMemRgb8* img = dynamic_cast<AImageMemRgb8*>(_img.get());
	  if(!img)
    {
		  return 0;
    }

    int w = img->Width();
    int h = img->Height();
    int size = w * h;

    std::vector<float> edgeStrength(size);
    std::vector<float> xDir(size);
    std::vector<float> yDir(size);

    float sigma = 1.0f;
    float nSigmasEnv = 3.0f;
    float histThStart = 10.0f;
    float histThEnd = 0.0f;

    DiZenzoEdgeDetector<float> diZenzo;
    diZenzo.Apply(img, &(edgeStrength[0]), &(xDir[0]), &(yDir[0]), sigma,
                                           nSigmasEnv, histThStart, histThEnd);

    SaveNormImageArray(&(edgeStrength[0]), img->Width(), img->Height(), fname,
                                                                   "_DiZenzo");
  }
}