// boost_mtr_test.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <iomanip>


#include "num_linalg.h"
#include "tests.h"

using namespace Vtl::NumAlg::Lin;




int Tests::test_boost_mtr(int argc, char* argv[])
{

	//float m23_data[]={1,2,3,4,5,6};
	ublas::c_matrix<float,2,3> m23;
	ublas::c_vector<float,3> v3;
	ublas::c_vector<float,3> v3_1;
	//m23=1,2,3,4,5,6;
	m23(0,0)=1;
	m23(0,1)=2;
	m23(0,2)=3;
	m23(1,0)=4;
	m23(1,1)=5;
	m23(1,2)=6;
	v3(0)=10;
	v3(1)=100;
	v3(2)=1000;
	v3_1(0)=1;
	v3_1(1)=2;
	v3_1(2)=3;

	std::cout << m23 << std::endl;
	std::cout << v3 << std::endl;

	ublas::c_vector<float,2> v2;
	v2(0)=2;
	v2(1)=4;
	v2 = prod(m23,v3) ;
	std::cout << v2 << std::endl;
	//v2=v2+v3;
	std::cout << v3+v3_1 << std::endl;
	v3_1=v3+v3_1;
	std::cout << v3_1 << std::endl;
	v3_1*=4;
	std::cout << v3_1 << std::endl;
	v3_1/=2;
	std::cout << v3_1 << std::endl;
	v3_1=v3_1/2.0f;
	std::cout << v3_1 << std::endl;
	//std::cout << v3*m23 << std::endl;

	ublas::c_matrix<float,5,3> A;
	ublas::c_vector<float,5> b;
	ublas::c_vector<float,3> x;
	A(0,0)=1;	A(0,1)= 6;	A(0,2)=11;
	A(1,0)=2;	A(1,1)= 7;	A(1,2)=12;
	A(2,0)=3;	A(2,1)= 8;	A(2,2)=13;
	A(3,0)=4;	A(3,1)= 9;	A(3,2)=14;
	A(4,0)=5;	A(4,1)=10;	A(4,2)=15;
	b(0)=5000;
	b(1)=4000;
	b(2)=3000;
	b(3)=2000;
	b(4)=1000;
	x(0)=1;
	x(1)=2;
	x(2)=3;
	std::cout << "A" << A << std::endl;
	std::cout << "x" << x << std::endl;
	std::cout << "b" << b << std::endl;
	std::cout << "ublas::prod(A,x)+b; =" << ublas::prod(A,x)+b << std::endl;
	std::cout << "ublas::prod(A,x); =" << ublas::prod(A,x) << std::endl;
	std::cout << "ublas::prod(b,A); =" << ublas::prod(b,A) << std::endl;
	std::cout << "ublas::prec_prod(A,x); =" << ublas::prec_prod(A,x) << std::endl;
	std::cout << "ublas::prec_prod(b,A); =" << ublas::prec_prod(b,A) << std::endl;
//	b=ublas::prod(A,x)+b;

	prod_diag(A,x);
	std::cout << "prod_diag(A,b); =" << A << std::endl;
	prod_diag(b,A);
	std::cout << "prod_diag(b,A); =" << A << std::endl;


	ublas::c_matrix<float,5,3> B;
	B=A;
	std::cout << "m23" << m23 << std::endl;
	std::cout << "m23.size1()" << m23.size1() << std::endl;
	std::cout << "m23.size2()" << m23.size2() << std::endl;

	{
		ublas::c_matrix<float,5,3> A;
		ublas::c_vector<float,5> b;
		ublas::c_vector<float,3> x;
		A(0,0)=1;	A(0,1)= 6;	A(0,2)=11;
		A(1,0)=2;	A(1,1)= 7;	A(1,2)=12;
		A(2,0)=3;	A(2,1)= 8;	A(2,2)=13;
		A(3,0)=4;	A(3,1)= 9;	A(3,2)=14;
		A(4,0)=5;	A(4,1)=10;	A(4,2)=15;
		
		float tmp[3];
		ublas::c_matrix<float,5,3> U;
		ublas::c_matrix<float,3,3> V;
		ublas::c_vector<float,3> s;

		std::cout << std::endl<< "svd: ============== " << std::endl;
		float relerr=1.0e-05f;
		U=A;
		svd::decomp(U,s,V,tmp);
		std::cout << "svd: A" << A << std::endl;
		std::cout << "svd: U" << U << std::endl;
		std::cout << "svd: S" << s << std::endl;
		std::cout << "svd: V" << V << std::endl;

		std::cout << "svd inv : ============== " << std::endl;
		ublas::c_matrix<float,3,5> Ainv;
		svd::inverse(Ainv,U,s,V,relerr);

		std::cout << "svd: A" << A << std::endl;
		std::cout << "svd: U" << U << std::endl;
		std::cout << "svd: S" << s << std::endl;
		std::cout << "svd: V" << V << std::endl;


		std::cout << "svd: Ainv" << Ainv << std::endl;

		std::cout << "svd: A*Ainv*" << prod(A,Ainv) << std::endl;
		std::cout << "svd: Ainv*A" << prod(Ainv,A) << std::endl;
		{
			std::cout << std::endl << "===  eigen ===========" << std::endl;
			A(0,0)=1;	A(0,1)= 6;	A(0,2)=11;
			A(1,0)=2;	A(1,1)= 7;	A(1,2)=12;
			A(2,0)=3;	A(2,1)= 8;	A(2,2)=13;
			A(3,0)=4;	A(3,1)= 9;	A(3,2)=14;
			A(4,0)=5;	A(4,1)=10;	A(4,2)=15;
			svd::inverse_save(Ainv,A,relerr);
			std::cout << "inverse_save " << Ainv << std::endl;
			ublas::c_vector<float,5> b;
			ublas::c_vector<float,5> x;
			b[0]=4; b[1]=5; b[2]=5; b[3]=5; b[4]=5; 
			x=svd::solve_save(A,b,relerr);
			std::cout << "solve_save " << x << std::endl;


		}
		{
			std::cout << std::endl << "===  eigen ===========" << std::endl;
			ublas::c_matrix<float,3,3> A;
			ublas::c_matrix<float,3,3> V;
			ublas::c_vector<float,3> e;
			ublas::c_vector<float,3> work;
			A(0,0)=3;	A(0,1)= 2;	A(0,2)=3;
			A(1,0)=2;	A(1,1)= 4;	A(1,2)=0;
			A(2,0)=3;	A(2,1)= 0;	A(2,2)=6;
			V=A;
			eigen::decomp(V,e,work); 
			std::cout << "eigen: eig=" << e <<std::endl << "V=" << V << std::endl;
			ublas::c_matrix<float,3,3> Ainv;
			eigen::inverse(Ainv,V,e,relerr);
			std::cout << "eigen: A*Ainv=" << prod(A,Ainv) <<std::endl ;

		}
		{
			std::cout << std::endl << "===  cholesky ===========" << std::endl;
			ublas::c_matrix<float,3,3> A;
			ublas::c_matrix<float,3,3> L;
			ublas::c_matrix<float,3,3> X;
			A(0,0)=3;	A(0,1)= 2;	A(0,2)=3;
			A(1,0)=2;	A(1,1)= 4;	A(1,2)=0;
			A(2,0)=3;	A(2,1)= 0;	A(2,2)=6;
			cholesky::decomp(A,L); 
			std::cout << "cholesky: L=" << L <<std::endl << std::endl;
			X = ublas::prod(L,trans(L)) ;
			std::cout << "cholesky: L*transp(L)=" << X <<std::endl << std::endl;
		}
		{
			std::cout << std::endl << "===  LU ===========" << std::endl;
			ublas::c_matrix<float,3,3> A;
			ublas::c_matrix<float,3,3> LU;
			ublas::c_matrix<float,3,3> L;
			ublas::c_matrix<float,3,3> U;
			ublas::c_matrix<float,3,3> X;
			A(0,0)=3;	A(0,1)= 2;	A(0,2)=3;
			A(1,0)=2;	A(1,1)= 4;	A(1,2)=0;
			A(2,0)=3;	A(2,1)= 0;	A(2,2)=6;
			LU=A;
			ublas::lu_factorize(LU); 
			std::cout << "LU: LU=" << LU <<std::endl << std::endl;

//        m.assign (triangular_adaptor<matrix_type, strict_lower> (lr) +
//                  triangular_adaptor<matrix_type, upper> (ur));
			L.assign( ublas::triangular_adaptor<ublas::c_matrix<float,3,3>,ublas::strict_lower>(LU) );
			U.assign( ublas::triangular_adaptor<ublas::c_matrix<float,3,3>,ublas::upper>(LU) );
			for(int i=0; i<3; ++i)
				L(i,i)=1;
			std::cout << "LU: L=" << L <<std::endl << std::endl;
			std::cout << "LU: U=" << U <<std::endl << std::endl;
			X = ublas::prod(L,U) ;
			std::cout << "LU: L*U=" << X <<std::endl << std::endl;
			std::cout << "LU: A-L*U=" << A-X <<std::endl << std::endl;
			std::cout << "LU: norm_1(A-L*U)=" << ublas::blas_1::asum(A-X) << std::endl;
//			std::cout << "LU: norm_2(A-L*U)=" << ublas::blas_1::nrm2(A-X) << std::endl;
//			std::cout << "LU: norm_inf(A-L*U)=" << ublas::blas_1::amax(A-X) << std::endl;
		}
		{
			std::cout << std::endl << "===  QR ===========" << std::endl;
			ublas::c_matrix<float,3,3> A;
			ublas::c_matrix<float,3,3> QR;
			ublas::c_matrix<float,3,3> Q;
			ublas::c_matrix<float,3,3> R;
			ublas::c_vector<float,3> Rdiag;
			ublas::c_matrix<float,3,3> X;
			A(0,0)=3;	A(0,1)= 2;	A(0,2)=3;
			A(1,0)=2;	A(1,1)= 4;	A(1,2)=0;
			A(2,0)=2;	A(2,1)= 0;	A(2,2)=7;
			QR=A;
			QR::decomp(QR,Rdiag);
			std::cout << "QR: QR=" << QR <<std::endl << std::endl;
			QR::getR(QR,Rdiag,R);
			QR::getQ(QR,Rdiag,Q);
			std::cout << "QR: Q=" << Q <<std::endl << std::endl;
			std::cout << "QR: R=" << R <<std::endl << std::endl;
			X=prod(Q,R);
			std::cout << "QR: Q*R=" << X <<std::endl << std::endl;
			X-=A;
			std::cout << "LU: A-Q*R=" << X <<std::endl << std::endl;
			std::cout << "LU: asum(A-Q*R)=" << ublas::blas_1::asum(X) << std::endl;
			std::cout << "LU: amax(A-Q*R)=" << ublas::blas_1::amax(X) << std::endl;
			
			std::cout << "LU: amax(A)=" << ublas::blas_1::amax(A) << std::endl;
			std::cout << "LU: A=" << A << std::endl;
			std::cout << "LU: A(0,2)=" << A(0,2) << std::endl;
			std::cout << "LU: norm_1(A) (max abs el sum in COLUMN)=" << norm_1(A) << std::endl;
			std::cout << "LU: norm_inf(A) (max abs el sum in ROW)=" << norm_inf(A) << std::endl;
			std::cout << "LU: norm_frobenius(A) (sqrt from el sumsq)=" << norm_frobenius(A) << std::endl;

			std::cout << "LU: matrix_max_abs_element(A)=" << matrix_max_abs_element(A) << std::endl;

			std::cout << "LU: norm_frobenius(X) (sqrt from el sumsq)=" << norm_frobenius(X) << std::endl;
			std::cout << "LU: matrix_max_abs_element(X)=" << matrix_max_abs_element(X) << std::endl;

		}
	}



	std::cout << "====================================" <<std::endl;
	return 0;
}

