#include <stdio.h>
#include <string>
#include <sstream>

#include "plf_filters.h"

#include "tests.h"

namespace Tests
{
	static void printImageRef(Vtl::Plf::ImageRef<int>& ir, int id)
	{
		printf("------<%d>--------\n",id);
		for(int y=-ir.ext().before ; y<=ir.ext().forward; y++ )
		{
			printf("%c  ",(y==0)?'c':'-');
			int x=-ir.ext().left;
			for( ; x<0; x++)
				printf("%2d",ir[y][x]);
			printf(" | ");
			for( ; x<ir.w() ; x++)
				printf("%2d",ir[y][x]);
			printf(" | ");
			for( ; x < (ir.w()+ir.ext().right) ; x++)
				printf("%2d",ir[y][x]);
			printf("\n");
		}
	}

	int test_plf_StripBuffer(int argc, char* argv[])
	{
		typedef Vtl::Plf::StripBuffer<int> SBuffer;
		SBuffer buf;
		const int w=5;
		const int h=7;
		Vtl::Plf::Extent ex(3,2,1,2);
		buf.init_1(Vtl::Plf::ImgSize(w,h));
		buf.init_2(ex);
		buf.init_3(0);
		buf.init_4();

		for(int y=0,yy=0; buf.Y()< h ; )
		{
			if(buf.Y_wait()<h)
			{
				buf.InsertNextLineStart();
				SBuffer::Iter_Line it=buf.begin_line_insert();
				int y=buf.Y_wait(); //  
				for(int x=0,d=1; x<w; x++)
				{
					*it++=y+d;
		#if 0
					if(x<w/2)
						++d;
					else
						--d;
		#endif
				}
				buf.InsertNextLineFinished();
			}
			else //if(buf.is_TailData())
			{
				buf.PopTail();
			}

			if(buf.Y()>=0) 
			{
				Vtl::Plf::ImageRef<int> ir=buf.getImg();
				printImageRef(ir, yy++);
			}

		}
		return 0;
	}
}//namespace Tests
