#include <string>
#include <sstream>
#include <memory> //auto_ptr()
#include <assert.h>

#include "aimage.h"
#include "yfilesys.h"
#include "consolap.h"

#include "plf_filters.h"
//#include "plf_filters_complex.h"
#include "plf_sys.h"
//#include <time.h>
//#include "Sidorkina/plt_filter_image.h"
#include "color_spaces.h" 

#include "tests.h"
namespace Tests
{
int test_shadow_detection_hsi(int argc,char *argv[])
{
	if(argc<2)
	{
		std::cout << "Command string: this.exe input_rgb_file " <<std::endl;
		return 1;
	}
	std::string fname_in=argv[1];
//		std::string fname_in="loreo_076.bmp";


		std::string fname_out=YFileSys::getNameWithoutExt(fname_in);

		std::auto_ptr<AImage> _in(::AImageLoad(0,true,fname_in.c_str(),indicator));
		AImageMemRgb8 *in=dynamic_cast<AImageMemRgb8 *>(_in.get());
		if(in==0)
			return 1;
		AImageMem8 * r=in->GetPlane8(0);	
		AImageMem8 * g=in->GetPlane8(1);
		AImageMem8 * b=in->GetPlane8(2);		
		AImageMem8 * h=in->GetPlane8(0);
		AImageMem8 * s=in->GetPlane8(1);
		AImageMem8 * i=in->GetPlane8(2);
		

		int height=r->Height();
		int width=r->Width();
		int nls=r->NextLineShift();

		const float sqrt_6=sqrt(6.0f);
		const float mn=float(255/(2*M_PI));


		
		uint8_t *pr=(*r)[0];
		uint8_t *pg=(*g)[0];
		uint8_t *pb=(*b)[0];
		uint8_t *ph=(*h)[0];
		uint8_t *ps=(*s)[0];
		uint8_t *pi=(*i)[0];

		int P[256];//   255 !!!!!!!!
		for(int x=0;x<256;x++) 
			P[x]=0;

		
		for(int y=0; y<height; y++)
		{
			for(int x=0; x<width; x++)
			{
				//pi[x]=(pr[x]+pb[x]+pg[x])/3;
				//-  !!! pi[x]  pb[x] -     .    v1    !
				float intensity=(float(pr[x])+float(pb[x])+float(pg[x]))/3.0f;//  3   unsigned char     unsigned char, ..          256 !
				//         float(value),    - (float)value
				//     "   "     ,   ,
				//    .     ,       const .
				const float v1=float((-pr[x]-pg[x]+2*pb[x])/sqrt_6); //      6     6       6 !
				const float v2=float((pr[x]-2*pg[x])/sqrt_6);
				pi[x]=uint8_t(intensity);
//				ph[x]=uint8_t((M_PI+atan(v2/v1))*mn); //   v1==0 ?  :
				ph[x]=uint8_t((M_PI+atan2(v2,v1))*mn); //      atan()  atan2()
	            ps[x]=uint8_t(ph[x]/(intensity+1)*40); //  h   i   0-255      ???  ,    !
				// 40 - .   .  -     float,     ,    unsigned char !

				//P[ps[x]-1]+=1; //   ps[x]==0 ?    ???
				P[ps[x]] +=1;
				/*if (ps[x]<100)
					ps[x]=255*exp(-(float)(ps[x]-200)*(ps[x]-200)/1600);
		`		else ps[x]=1;*/
			}
			pr+=nls;
			pg+=nls;
			pb+=nls;
			ph+=nls;
			ps+=nls;
			pi+=nls;
		}

		const int64_t size=width*height;
		int Ts=0;
#if 0
		double sum=0;
		while((sum<.95)||(Ts<255)) //     ?
		{
			P[Ts]=P[Ts]/size; //P[]   int.    ""   !
			sum+=P[Ts];//    ,     !
			Ts++;
		}
		double sigma=0;
		for(int y=0;y<Ts;y++) 
			sigma+=sqrt((float)P[y]*(y-Ts)*(y-Ts));
#else
		//   :
		int64_t sum=0;
		const int64_t max_sum=int64_t(0.95*size);
		for( Ts=0 ; (sum < max_sum ) && (Ts<256) ; ++Ts)
			sum+=P[Ts];
		double sigma=0;
		for(int y=0;y<Ts;y++) 
		{
			sigma+= (P[y]/double(size)) * Vtl::sqr(y-Ts);
		}
		sigma=sqrt(sigma);
#endif	
		std::cout << "Ts= " << Ts <<std::endl;
		std::cout << "sigma= " << sigma <<std::endl;
		
		sigma=2*sigma;
		
		uint8_t *pss=(*s)[0];
		uint8_t *pii=(*i)[0];
		
		for(int y=0; y<height; y++)
		{
			for(int x=0; x<width; x++)
			{
				if (pss[x]<Ts)
					pii[x]=uint8_t( 255 * exp( - Vtl::sqr( (pss[x]-Ts)/sigma ) ) );
				else pii[x]=255;
			}
			pss+=nls;
			pii+=nls;
		}

		//     ???
		//Vtl::Plf::FiltersSystem sys(fname_out+".dot");
		//sys.Run(indicator,fname_out.c_str());

		std::string fn=fname_out+"_H.pgm";
		::AImageSave(h,fn.c_str(),indicator);
		fn=fname_out+"_S.pgm";
		::AImageSave(s,fn.c_str(),indicator);
		fn=fname_out+"_I.pgm";
		::AImageSave(i,fn.c_str(),indicator);

		return 0;
}
}