// xml_test.cpp : Defines the entry point for the console application.
//

#include <iostream>

#include "xml_interface.h"
#include "yfilesys.h"


const char *DocName="ROUTE_ROOT";

const char * PspRoute="PASPORTROUTE";
const char * Kvater="Kvater";
const char * Akco="AKCO";
namespace Tests
{
	namespace Test_YXML
	{
		void fill_quaternions(YXML::DNode n,double q1,double q2,double q3,double q4)
		{
			//          _ ,  
			//   "1" -   .
			n["q1"]=q1;

			//     -:
			{
				std::ostringstream os;
				os << float(q2);
				n["q2"]=os.str();
			}
			{
				std::ostringstream os;
				os << std::setiosflags(std::ios::showpoint |std::ios::fixed) << std::setprecision(6) << q3;
				n["q3"]=os.str();
			}
			{
				std::ostringstream os;
				os << std::setiosflags(std::ios::showpoint|std::ios::fixed) << std::setprecision(3) ;
				os << q4;
				n["q4"]=os.str();
			}
		}

		void fill_document(YXML::DNode node)
		{
			//   -    ,
			//     .

			//   -  ,       
			//   ,        ,
			//       - .
			node["Version"]="1.0.0.0";
			node["nNumberKA"]=33;
			node["cCodeKA"]="PRS";
			node["cCodePPI"]="124";
			node["cStation"]="..OPTECS";
			node["dDateHeaderFile"]="07/02/2007";
			//   -    ,      ELEMENT,
			//  ,     . 
			// :     - ,    -    
			//  ,   ELEMENT     
			// (, ,  )    .
			node("cFormatNamePasport")="REZZP";
			node("cOrganization")="GKNPC";
			node("cProgramm")="RNII KP .FormSatM";
			//       ,   !
			//      ,      
			//     .
			node("TEST")="Asdf <  > 111 & > /  ;  \" aa \\ bb (){}|[] end";



			YXML::DNode n_route=node(PspRoute);
			n_route("cBSEModeType")="ZAP";
			n_route("nPickupNum")=1;
			n_route("nCycleNum")=1245;
			n_route("nCycleRouteNum")=1;
			n_route("nWPNum")=4;
			n_route("dDateRoute")="07/03/2007";
			n_route("tTimeRoutePlan")="05:12:20.600000";
			//       (,  
			//            
			//,       ).
			{
				YDataTime dt(2007,3,7,5,12,20.600123);
				YTimeInterval zone(0,3,0,0);
				//   
				int day=dt.Day();
				int year_day=dt.YearDay();
				int minutes=dt.Minutes();
				double seconds_from_1_Jan=dt.YearDaySec();
				//     
				YDataTimeZone dtz(dt,zone);
				//   XML  :
				DataString ds;
				ds.setDataTime_Precision(6);//  XML - 3 ,  , 
				//         -   .
				ds=dtz;
				n_route("DataTime_RoutePlan")=ds;
			}

			n_route("nDeltaTimeRoute")=600;
			n_route("cDevMode")="S";
			//    :
			node(PspRoute)("nOEPQuantity")=1;
			node(PspRoute)("bOEPNumbers")=1;
			node(PspRoute)("nCycleCommunic")=2;
			//          
			//      
			node(PspRoute)("cFileType")["Format"]="TIFF";
			node(PspRoute)("cFileType")["bits"]=8;
			node(PspRoute)("cFileType")["ImageClass"]="GrayScale";// PALETTE  RGB 


			n_route("nFactorCompres")=4;
			n_route("nFilesNum")=1;
			{
				YDataTime dt(2007,3,7,5,12,20.600321);
				YTimeInterval zone(0,3,0,0);
				//     
				YDataTimeZone dtz(dt,zone);
				//   XML :
				DataString ds;
				ds.setDataTime_Precision(6);//  XML - 3 ,  , 
				//         -   .
				ds=dtz;
				n_route("DateZeroBSHV")=ds;
			}

			n_route("aViewAngle")="000:00:00.000000";

			//    ,     
			//   ,      
			// .
			// !        ( ),
			//       ,     .
			// ,        -    .
			//  -    .
			YXML::DNode n_kv=node.AppendChild(YXML::DNode::ELEMENT,Kvater);
			
			for(int i=1; i<=3; i++)
			{
				if(i!=1)
					n_kv=n_kv.InsertAfter(YXML::DNode::ELEMENT,Kvater);

				n_kv[Akco]=DataString(i);
				n_kv("nSKOAKCO")["X"]=000.00;
				n_kv("nSKOAKCO")["Y"]=000.00;
				n_kv("nSKOAKCO")["Z"]=000.00;
				n_kv("nAnglPointsQuant")=11;
				//n("bDTime")=1,2,3,4;
				{
					//   :
					YXML::DNode nBL=n_kv.AppendChild(YXML::DNode::ELEMENT,"bL");
					nBL["N"]=0;
					fill_quaternions(nBL,0,-0.0000001,0.0000222,1.0);
					//     ,  
					//    .   
					//  nBL ,    nBL -   .

					nBL=nBL.InsertAfter(YXML::DNode::ELEMENT,"bL");
					nBL["N"]=1;
					fill_quaternions(nBL,-0.0000001,0.0000222,1.0,0.3);

					nBL=nBL.InsertAfter(YXML::DNode::ELEMENT,"bL");
					nBL["N"]=2;
					fill_quaternions(nBL,-0.0000001,0.0000222,1.0,0.12);

					nBL=nBL.InsertAfter(YXML::DNode::ELEMENT,"bL");
					nBL["N"]=3;
					fill_quaternions(nBL,-0.0000001,0.0000222,1.0,-0.123456);
				}
			}
			{
				YXML::DNode n_izm=node("StarIZM");
				n_izm["N"]=1;
				n_izm("nSKOStarR")=000.00;
				n_izm("nSKOStarC")=000.00;
				n_izm("nStarPointsQuant")=111;
				//     , 
				//   -    ,   .
				std::string separetor=" ";
				{
					std::ostringstream os;
					os << 1 << separetor << 2 << separetor << 3 << separetor << 4 << separetor << 5;
					n_izm("bDTime")=os.str();
				}
				{
					std::ostringstream os;
					os << 1 << separetor << 2 << separetor << 3 << separetor << 4 << separetor << 5;
					n_izm("bX")=os.str();
				}
				{
					std::ostringstream os;
					os << 1 << separetor << 2 << separetor << 3 << separetor << 3 << separetor << 20;
					n_izm("bY")=os.str();
				}
				{
					float bAlfa[]={000000.00f,000000.00f,000000.00f,000000.00f,000000.00f};
					std::ostringstream os;
					os << std::setiosflags(std::ios::showpoint|std::ios::fixed) << std::setprecision(2) ;
					for(int i=0; i<sizeof(bAlfa)/sizeof(bAlfa[0]) ; ++i)
						os << bAlfa[i] <<" "; 
					n_izm("bAlfa")=os.str();
				}
				{
					double bDelta[5]={0000.00,0000.00,0000.00,0000.00,0000.00};
					std::ostringstream os;
					for(int i=0; i<5 ; ++i)
						os << bDelta[i] <<" "; 
					n_izm("bDelta")=os.str();
				}

			}

		}

		void test_write_file(std::string filename)
		{
			YXML::XMLdoc doc;
			//   ,   ,  
			//    ,  :
			if(YFileSys::isFileExist(filename))
				std::cout << "File " << filename << " already exist, we'll overwrite it..." <<std::endl;
			else
				std::cout << "File " << filename << " NOT exist, we'll create it..." <<std::endl;

			doc.Create(filename.c_str(),DocName);
			YXML::DNode root=doc.Root();

			fill_document(root);

			doc.Save(filename.c_str(),true);
		}

		template<typename T>
		struct Ne
		{
			bool operator()(DataString ds,const T& v)
			{
				T va=ds;
				return va!=v;
			}
		};
		void read_document(YXML::DNode node)
		{
			DataString ds;
			//     ,      :
			ds=node("cFormatNamePasport")="REZZP";
			std::cout << ds << std::endl;
			//   :
			ds=node["dDateHeaderFile"];
			std::cout << ds << std::endl;

			//       :
			ds=node(PspRoute)("nCycleCommunic");
			int nCycleCommunic=ds;
			std::cout << nCycleCommunic << std::endl;

			ds=node(PspRoute)("cFileType")["Format"];
			std::cout << ds << std::endl;

			//  :

			//      "Kvater"
			YXML::DNode n_kv=node.FirstChild(Kvater);
			while(n_kv.IsNode())
			{
				//   ,  
				int i=DataString(n_kv[Akco]);
				std::cout << i << std::endl;
				int nSKOAKCO_Y=DataString(n_kv("nSKOAKCO")["Y"]);
				std::cout << nSKOAKCO_Y << std::endl;

				//   "bL"   N=2
				{
					int nn=2;

					YXML::DNode n_bL=n_kv.FirstChild("bL","N",DataString(nn));
					while(n_kv.IsNode())
					{
						std::cout << "bL :" << std::endl;
						std::cout << DataString(n_bL["N"]) << std::endl;
						std::cout << DataString(n_bL["q1"]) << std::endl;
						std::cout << DataString(n_bL["q2"]) << std::endl;
						std::cout << DataString(n_bL["q3"]) << std::endl;
						std::cout << DataString(n_bL["q4"]) << std::endl;

						//      
						//n_bL=n_bL.Next("bL","N",N);
						break;
					}
				}


				//    "bL"   N!=1 ,  1000 > q4 > 0.1 
				{
					YXML::DNode::IsCond cond(YXML::IsNameEq("bL") 
						&& YXML::IsAttr<int,Ne<int> >("N",1) 
						&& YXML::IsAttrIn<double>("q4",0.1,1000.) );
					// ,  
					YXML::DNode n_bL=n_kv.FirstChild(cond);
					while(n_bL.IsNode())
					{
						std::cout << "N=" << DataString(n_bL["N"]) 
							<< " q4=" << DataString(n_bL["q4"]) <<  std::endl;

						n_bL=n_bL.Next(cond);
					}
				}

				//:
				n_kv=n_kv.Next(Kvater);
			}


		}

		void test_read_file(std::string filename)
		{
			YXML::XMLdoc doc;
			//   ,   ,  
			//    ,  :
			if(YFileSys::isFileExist(filename))
				std::cout << "Read File " << filename << " exist, we'll read it..." <<std::endl;
			else
			{
				std::cout << "File " << filename << " NOT exist, can't read it..." <<std::endl;
				return;
			}

			doc.Load(filename.c_str());
			YXML::DNode root=doc.Root();

			read_document(root);

			doc.Save(filename.c_str(),true);
		}
	}//namespace Test_YXML

	int test_yxml_learn(int argc, char* argv[])
	{
		try
		{
			std::string fname="StarSky.xml";
			
			std::cout << "Test writing file" << std::endl;

			Test_YXML::test_write_file(fname);

			std::cout << "Test reading file" << std::endl;

			Test_YXML::test_read_file(fname);
		}
		catch(std::string msg)
		{
			std::cout << "Exception occured: " << std::endl << msg << std::endl;
		}
		catch(const char * msg)
		{
			std::cout << "Exception occured: " << std::endl << msg << std::endl;
		}
		catch(...)
		{
			std::cout << "Unknown Exception occured" << std::endl;
			throw; //   ,  - , 
			//   ,  Windows  - . 
			//         ...
		}

		return 0;
	}

}//namespace Tests
