#ifndef _TESTS_H
#define _TESTS_H
////////////////////////////////////////////////////////////////////////////////////////
namespace TestsSat
{
	//======== Satellite Image processing tests ========================================================
	int sat_test_albedo(int argc,char *argv[]);
	int sat_test_fire(int argc, char* argv[]);
	int sat_test_stripe_registration(int argc,char *argv[]); 
}//namespace TestsSat
namespace Tests
{
	//======== Test general purpose components ==============================================
	int test_alexandresku(int argc,char* argv[]);
	int test_boost_mtr(int argc, char* argv[]);
	int test_Sscanf(int argc, char* argv[]);
	int test_meta_determinant(int argc,char* argv[]);
	//======== Test XML/INI files ===========================================================
	int test_YWinIni(int argc, char* argv[]);
	int test_XML(int argc, char* argv[]);
	int test_DataString(int argc, char* argv[]);
	int test_yxml_learn(int argc, char* argv[]);
	//======== Test numerical methods components ==============================================
	int test_spec_functions(int argc, char* argv[]);
	int test_Integral_Transforms(int argc, char* argv[]);
	//======== Test Pipe Line Filters========================================================
	int test_plf_kernels(int argc, char* argv[]);
	int test_plf_StripBuffer(int argc, char* argv[]);
	int test_plf_IO_Ports(int argc, char* argv[]);
	int test_plf_system_idea(int argc, char* argv[]);
	int test_plf_Filter(int argc, char* argv[]);
	int test_plf_Filter_rgb(int argc, char* argv[]);
	//======== Test Image Algorithms Tools=====================================================
	int test_alg_bresenham(int argc,char* argv[]);
	int test_color_spaces(int argc,char *argv[]);
	int test_fast_gauss(int argc, char* argv[]);
	//======== Test Image registration ========================================================
	int test_image_registration_via_fft(int argc,char *argv[]);
	int test_color_registration(int argc,char *argv[]);
	//======== Experimental ========================================================
	int test_image_registration_via_oflow(int argc,char *argv[]);
	int test_vtl_ND_image(int argc,char* argv[]);
	int test_gc2009(int argc,char* argv[]);
	//======== Test Students ========================================================
	int test_basics3D(int argc, char* argv[]);

	int test_line_curvature(int argc,char *argv[]);
	int TestImgFromGrad(int argc, char *argv[]);
	int TestEdgeDetectors(int argc, char *argv[]);
	int TestEDT(int argc, char *argv[]);
	int TestDerivatives(int argc, char *argv[]);

	int test_wire_detection(int argc,char *argv[]);
	int test_color_blob(int argc,char *argv[]);

	int test_shadow_detection_hsi(int argc,char *argv[]);
	int test_shadow_detection_invariant(int argc,char *argv[]);
	
	int test_curve_analysis(int argc,char *argv[]);
	
	int test_img_enhancement(int argc,char *argv[]);
	int test_medical_3d_image(int argc, char* argv[]);

}//namespace Tests
////////////////////////////////////////////////////////////////////////////////////////
#endif //_TESTS_H
