#include <stdio.h>
#include <conio.h>
#include "progrcnt.h"

class SimpleProgressBar
: public ProgressCounter
{
	int _start;
	int _end;
public:
	SimpleProgressBar() {_start=_end=0;}
	virtual ~SimpleProgressBar() {_start=_end=0;}
	// next virtual functions MUST redeclared to draw ProgressBar
	// and user abort capability. These functions called ONLY by process.
	virtual bool russian() const         { return false; }
#if _MSC_VER >= 1400
	virtual void start(const char *filter_name,int count_start,int count_end)
	{
		::_cprintf("\n====== %s  =========\n",filter_name);
		_start=count_start;
		_end=count_end;
	}
	virtual bool current(int count_current)
	{ // if return true - process will aborted
		if(_kbhit())
		{
			while(_kbhit()) _getch();
			return true;// abort process
		}
		else
		{
			double perc=100.*double(count_current-_start)/double(_end-_start);
			::_cprintf("%5.1lf%%\r",perc);
		}
		return false; // continue processing
	}
	virtual void finish()                
	{ 
		/*::cprintf("%5.1lf%%, OK\n",100.0);*/
		::_cprintf("\n=========================\n"); 
		_start=_end=0; 
	}
	virtual void error(const char *msg)  
	{ 
		::_cprintf("\n%s\n",msg); 
	}
#else
	virtual void start(const char *filter_name,int count_start,int count_end)
	{
		::cprintf("\n====== %s  =========\n",filter_name);
		_start=count_start;
		_end=count_end;
	}
	virtual bool current(int count_current)
	{ // if return true - process will aborted
		if(kbhit())
		{
			while(kbhit()) getch();
			return true;// abort process
		}
		else
		{
			double perc=100.*double(count_current-_start)/double(_end-_start);
			::cprintf("%5.1lf%%\r",perc);
		}
		return false; // continue processing
	}
	virtual void finish()                
	{ 
		/*::cprintf("%5.1lf%%, OK\n",100.0);*/
		::cprintf("\n=========================\n"); 
		_start=_end=0; 
	}
	virtual void error(const char *msg)  
	{ 
		::cprintf("\n%s\n",msg); 
	}
#endif
	virtual bool InProgress() const 
	{
		return bool(_start || _end);
	}
};


static SimpleProgressBar sb;
ProgressCounter *indicator=&sb;