#ifndef _YFILE_H
#define _YFILE_H
////////////////////////////////////////////////////////////////////////////////
#include <string>
#include "ytypes.h"
#include "ytime.h"
/** @defgroup FileGroup    . 
 *  @ingroup GeneralGroup
 *  @{
 */
//>-----------------------------------------------------------------------------
/*!
 * class YFile
 * \brief        /.     
 *   .    ,  - .
 *  -     ,    .  ,
 *           Windows     ,
 *    ,      .
 ******************************************************************************************************/
class YFile
{
public:
	enum OpenMode
	{
		UIO_CREATE,
		UIO_CREATE_OVERWRITE,
		UIO_RDONLY,
		UIO_MODIFY,
		UIO_UNKNOWN
	};
private:
	char handle[16];
	OpenMode mode;
public:
	YFile();
	virtual ~YFile();
	int _open(std::string filename,OpenMode access) {return _open(filename.c_str(),access);}
	int _open(const char * filename,OpenMode access);
	int _close();
	int _read(int64_t pos,void *data,int32_t len);
	int _write(int64_t pos,const void *data,int32_t len);
	OpenMode GetMode() const {return mode;}
	virtual bool IsOk() const;
};
//>-----------------------------------------------------------------------------
/*!
 * class YFileRead
 * \brief        .      
 *   .    ,  - .
 *  -     ,    .  ,
 *           Windows     ,
 *    ,      .
 ******************************************************************************************************/
class YFileRead
{
	char handle[16];
private:
	YFileRead(const YFileRead&);
	void constructor(const char * filename);
public:
	YFileRead(std::string filename) {constructor(filename.c_str());}
	YFileRead(const char *filename) {constructor(filename);}
	virtual ~YFileRead();
	void _close();
	void SetPosition(int64_t offset);
	int read(void* data,int len);
	int read(int64_t offset,void* data,int len);
	int64_t GetFileSize() const;
	YDataTime GetTime() const;
};
//>-----------------------------------------------------------------------------
/*!
 * class YFileWrite
 * \brief        .      
 *   .    ,  - .
 *  -     ,    .  ,
 *           Windows     ,
 *    ,      .
 ******************************************************************************************************/
class YFileWrite
{
	char handle[16];
private:
	YFileWrite(const YFileWrite&); 
	void constructor(const char * filename); 
public:
	YFileWrite(std::string filename) {constructor(filename.c_str());}
	YFileWrite(const char *filename) {constructor(filename);}
	virtual ~YFileWrite();
	void _close();
	void SetPosition(int64_t offset);
	int64_t GetPosition();
	int write(const void* data,int len);
	int write(int64_t offset,const void* data,int len);
};
//>-----------------------------------------------------------------------------
/*!
 * class DebugBase
 *   . Deprecated.        .
 *
 ******************************************************************************************************/
class DebugBase
{
public:
	DebugBase() {}
	virtual ~DebugBase() {}
	virtual void Close()=0;
	virtual int printf(const char *format,...) const=0;
};
//-----------------------------------------------------------------------
/*!
 * class DebugToFile
 *        . Deprecated.      
 *   .
 *
 ******************************************************************************************************/
class DebugToFile
: public DebugBase
{
	std::string debug_fname;
	void *fp_debug;//(FILE*)
public:
	DebugToFile();
	virtual ~DebugToFile();
	std::string DebugFileName() const { return debug_fname; }
	void Init(const char* fname);
	virtual void Close();
	virtual int printf(const char *format,...) const;
};
//-----------------------------------------------------------------------
/** @} */ // end of FileGroup  
////////////////////////////////////////////////////////////////////////////////
#endif //_YFILE_H
