#include "ymem.h"

void YSmallAllocLtd::nullify()
{
	data=0;
	f=0;
	objsz=0;
	num=0;
	count=0;
	memsz=0;
}
//virtual 
YSmallAllocLtd::~YSmallAllocLtd()
{
	DeInit();
}

YSmallAllocLtd::YSmallAllocLtd()
{
	nullify();
}

YSmallAllocLtd::YSmallAllocLtd(unsigned size_of_object,unsigned maximal_number_of_objects,unsigned max_tail)
{
	nullify();
	Init(size_of_object,maximal_number_of_objects,max_tail);
}

void YSmallAllocLtd::DeInit()
{
	if(data)
	{
		delete[] data;
		nullify();
	}
}

void YSmallAllocLtd::Init(unsigned size_of_object,unsigned maximal_number_of_objects,unsigned max_tail)
{
	if(size_of_object < sizeof(void*)) 
		size_of_object=sizeof(void*);
	unsigned sz=size_of_object*maximal_number_of_objects;
	if(data)
	{//object already Init, test does the memory block need reallocation.
		if(sz<=memsz && (memsz+max_tail) <= sz)
		{
			objsz=size_of_object;
			num=memsz/size_of_object;
			erase_all();
			return;
		}
		DeInit();
	}
	try
	{
		data=new Byte[sz];
		if(!data)
			throw 1;
		memsz=sz;
		objsz=size_of_object;
		num=maximal_number_of_objects;
		erase_all();
	}
	catch(...)
	{
		throw "YSmallAllocLtd::Init() : Can't allocate memory pool";
	};
}
void * YSmallAllocLtd::malloc()
{
	if(f)
	{
		Byte *p=f;
		f=*((BytePtr*)p);
		return p;
	}
	return 0;
}
void YSmallAllocLtd::free(void *ptr)
{
#ifdef DEBUG_PRG_CHECK
	if(ptr<data || ptr>data+(memsz-objsz);
		throw "YSmallAllocLtd::free() : attempt free object which allocated not by this object";
#endif
	*((BytePtr*)ptr)=f;
	f=(Byte *)ptr;
}

void YSmallAllocLtd::erase_all()
{
	if(data)
	{
		count=0;
		unsigned cnt=num-1;
		Byte *p=data;
		f=p;
		while(cnt--)
		{
			Byte* pp=p+objsz;
			*((BytePtr*)p)=pp;
			p=pp;
		}
		*((BytePtr*)p)=0;
	}
}

