#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#pragma hdrstop
#include <memory.h>
#include "iFloat.H"

using namespace IFF;

static const char* FILE_STAMP="FloatImageFile";

FloatImageFile::FloatImageFile()
: YFile()
{
	::memset(&head,0,sizeof(head));
};
//virtual 
FloatImageFile::~FloatImageFile()
{
	close();
};

void FloatImageFile::open(const char * szFileName,OpenMode access,
			int  Width,int  Heigth)
{
	close();
	if(access==YFile::UIO_CREATE || access==YFile::UIO_CREATE_OVERWRITE)
	{
		if(Width<=0 || Heigth<=0 )
			throw "Invalid image size parameter";
	}
	YFile::_open(szFileName,access);
	if(!YFile::IsOk())
		throw "file open error";

	switch(this->GetMode())
	{
	case UIO_CREATE:
	case UIO_CREATE_OVERWRITE:
			::memset(&head,0,sizeof(head));
			head.width=Width;
			head.height=Heigth;
			//::strcpy((char*)(head.id),FILE_STAMP);
			for(int i=0 ; i < sizeof(head.id) ; ++i)
				head.id[i]=FILE_STAMP[i];
			head.hdrsize=sizeof(head);
			writeHeader();
			break;
	case UIO_RDONLY:
	case UIO_MODIFY:
			readHeader();
			break;
	default:
		throw "unknown file open mode";
	}
};

void FloatImageFile::close()
{
	memset(&head,0,sizeof(head));
	YFile::_close();
};

void FloatImageFile::readHeader()
{
	const int len=sizeof(head);
	int ll=_read(0,&head,len);
	if(ll<=sizeof(head.id) )
		throw "FloatImageFile::readHeader() : Invalid file format";
	else if(::strncmp((char *)(head.id),FILE_STAMP,sizeof(head.id)))
		throw "FloatImageFile::readHeader() : Invalid file format";
	if(head.hdrsize!=uint32_t(ll) || head.hdrsize<28)
		throw "FloatImageFile::readHeader() : probably file corrupted";
};

void FloatImageFile::writeHeader()
{
	const int len=sizeof(head);
	if(len!=_write(0,&head,len))
		throw "can't write FLOAT-header, probably disk full";
};

void FloatImageFile::read(int x,int y,FloatWord *line,int len)
{
	int ll=len*sizeof(FloatWord);
	if(ll!=_read(sizeof(head)+sizeof(FloatWord)*(head.width*y+x),line,ll))
		throw "can't read data, probably file corrupted";
};

void FloatImageFile::write(int x,int y,const FloatWord *line,int len)
{
	int ll=len*sizeof(FloatWord);
	if(ll!=_write(sizeof(head)+sizeof(FloatWord)*(head.width*y+x),line,ll))
		throw "can't write data, probably disk full";
};
