#ifndef _OZ_H
#define _OZ_H
////////////////////////////////////////////////////////////////////////////
#include "yfile.h"
////////////////////////////////////////////////////////////////////////////
namespace IFF
{
typedef uint16_t OzWord;
//
//  3.2   10-         
//   :
//
//                                     
//  + 7 - 6 - 5 - 4 - 3 - 2 - 1 - 0 +   + 7 - 6 - 5 - 4 - 3 - 2 - 1 - 0 +
//   0  0  0  0  0  0                                  
//  +-------------------------------+   +-------------------------------+
//                            9   8       7   6   5   4   3   2   1   0
//                                10-  
//
//+---------------------------------------------------------------------+
//                                    
//+-------------------------------------------------             
//      15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0              
//-----+-------------------------------------------------+-------------
//  1                                                   
//  2                                                   
//  3                                                           
//  4                                                   
//  5                                                             
//  6                                                 
//  7       ( .)              
//  8                                                       
//  9                                                          
// 10       ( .)                
// 11                                                     
// 12                                                      
// 13         [1 .. 4]                           
// 14     , 0 -10 bpp                  
// 15               [0]                                
// 16          - / -                                                 
//-----+-------------------------------------------------+-------------
//
//
class OzFile 
: protected YFile
{
public:
#pragma pack(push,1)
	struct Header 
	{
		OzWord Trajectory;
		OzWord day;
		OzWord month;
		OzWord year;
		OzWord begHour;
		OzWord begMinutes;
		OzWord begSecond1000;
		OzWord endHour;
		OzWord endMinutes;
		OzWord endSecond1000;
		OzWord Width;
		OzWord Length;
		OzWord Chan;
		OzWord Bits;//0 means -10 bit for backward compatibility
		OzWord reserved[2];
	};
#pragma pack(pop)
private:
	Header head;
public:
//	 
	void writeHeader();
	void readHeader();
public:
//	/ 
	OzFile();
	virtual ~OzFile();
	void open(const char * szFileName,OpenMode access,
				int  Width=0,int Height=0,int  bitsPerPixel=10);
	void close();
	//--------------------------------------------------
	void read(int x,int y,OzWord *line,int len);
	void write(int x,int y,const OzWord *line,int len);
	//------------------------------------------------
	int Width()  const { return head.Width; }
	int Length() const { return head.Length; }
	int Bits()   const { return head.Bits; }
	//--------------------------------------------------
	OzWord GetChanel() const;
	void   SetChanel(OzWord channel);
	OzWord GetTrajectory() const;
	void   SetTrajectory(OzWord traject);
	void   GetTime(OzWord& hour,OzWord& minutes,OzWord& seconds,OzWord& millisec) const;
	void   GetTimeEnd(OzWord& hour,OzWord& minutes,OzWord& seconds,OzWord& millisec) const;
	void   SetTime(OzWord hour,OzWord minutes,OzWord seconds,OzWord millisec);
	void   SetTimeEnd(OzWord hour,OzWord minutes,OzWord seconds,OzWord millisec);
	void   GetDate(OzWord& year,OzWord& month,OzWord& day) const;
	void   SetDate(OzWord year,OzWord month,OzWord day);
	void   GetHeader(Header* header) const;
	void   SetHeader(Header* header);
	bool   IsOneSeance(const OzFile& f) const;
};
} //namespace IFF
////////////////////////////////////////////////////////////////////////////
#endif //_OZ_H
