#ifndef _VTL_META_INDEXLIST_H
#define _VTL_META_INDEXLIST_H
///////////////////////////////////////////////////////////////////////////////////////////
#include <iostream>
#include "loki_typeManip.h"
#include "loki_NullType.h"
///////////////////////////////////////////////////////////////////////////////////////////

namespace Vtl
{
namespace Meta
{
	//------------------------------ IndexList -----------------------------------------------
	///   ,    .     .
	///          \ref Lit_Alexandresku 
	template<int i,class T=Loki::NullType>
	struct IndexList 
	{
		enum {value=i};
		typedef T Next;
	};
	///     IndexList
	namespace IL
	{
		/// Used for error reporting (invalid index in IndexList) during compile
		template<int j> struct ERROR__Index_out_of_IndexList_range {typedef int index;};
		///      (  ,   ).       -1         . 
		template<int i_0,int i_1=-1,int i_2=-1,int i_3=-1,int i_4=-1,int i_5=-1,int i_6=-1,int i_7=-1,int i_8=-1,int i_9=-1,int i_10=-1,int i_11=-1,int i_12=-1,int i_13=-1,int i_14=-1,int i_15=-1,int i_16=-1,int i_17=-1,int i_18=-1,int i_19=-1>
		struct Make
		{
			typedef IndexList<i_0,typename Make<i_1,i_2,i_3,i_4,i_5,i_6,i_7,i_8,i_9,i_10,i_11,i_12,i_13,i_14,i_15,i_16,i_17,i_18,i_19,-1>::Result > Result;
		};
		template<>
		struct Make<-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1>
		{
			typedef Loki::NullType Result;
		};
		///      i, i+1, i+2, ... n-1.  MakeInRange<12,15>::Result -    12,13,14.
		template<int i,int n>
		struct MakeInRange
		{
			typedef IndexList<i,typename MakeInRange<i+1,n>::Result > Result;
		};
		template<int n>
		struct MakeInRange<n,n>
		{
			typedef Loki::NullType Result;
		};
		///       i       IList.
		template<int i,class IList>
		struct PushFront
		{
			typedef IndexList<i,IList> Result;
		};
		///        IList       i.
		template<int i,class IList=Loki::NullType>	 
		struct PushBack;
		template<int i>                   
		struct PushBack<i,Loki::NullType >
		{
			typedef IndexList<i,Loki::NullType> Result;
		};
		template<int i,int j,class Tail>
		struct PushBack<i,IndexList<j,Tail> >
		{  
			typedef IndexList<j,typename PushBack<i,Tail>::Result > Result;
		};
		///        Head       Tail.
		template<class Head,class Tail> 
		struct ConCat;
		template<class Head,int i,class Tail> 
		struct ConCat<Head,IndexList<i,Tail> >
		{
			typedef typename ConCat<typename PushBack<i,Head>::Result,Tail>::Result Result;
		};
		template<class Head> struct ConCat<Head,Loki::NullType >
		{
			typedef Head Result;
		};
		///   ( )  IList.
		template<class IList> struct Length;
		template<> struct Length<Loki::NullType>
		{  
			enum {value=0}; 
		};
		template<int i,class T> 
		struct Length<IndexList<i,T> >
		{ 
			enum { value=1+Length<T>::value };
		};
		///    IList  i (      )      .      0.      -   -1.
		template<int i,class IList> struct IndexOf;
		template<int i> struct IndexOf<i,Loki::NullType>
		{
			enum { value = -1};
		};
		template<int i,class T> struct IndexOf<i,IndexList<i,T> >
		{
			enum { value = 0 };
		};
		template<int i,int j,class T> struct IndexOf<i,IndexList<j,T> >
		{
		private:
			enum { temp = IndexOf<i,T>::value};
		public:
			enum { value = (temp==-1) ? -1 : 1+temp };
		};
		///     ()    i ( ).      0.  i<0  i > Length<IList>::value,      ERROR__Index_out_of_IndexList_range.
		template<int i,class IList> struct Elem;
		template<int j,class T>
		struct Elem<0,IndexList<j,T> >
		{ 
			enum { value=j }; 
		};
		template<int i,int j,class T> 
		struct Elem<i,IndexList<j,T> >
		{ 
			enum { value=Elem<i-1,T>::value }; 
		};
		template<int i> struct Elem<i,Loki::NullType >
		{ 
			enum { value = ERROR__Index_out_of_IndexList_range<i>::index };
		};
		///     (,       )   i   .      ,      ERROR__Index_out_of_IndexList_range.
		template<int i,class IList> struct Erase;
		template<int i> struct Erase<i,Loki::NullType >
		{
			enum { value=ERROR__Index_out_of_IndexList_range<i>::index };
			typedef typename Loki::NullType Result;
		};
		template<int i,class T> struct Erase<i,IndexList<i,T> >
		{
			typedef T Result;
		};
		template<int i,int j,class T> struct Erase<i,IndexList<j,T> >
		{
			typedef IndexList<j,typename Erase<i,T>::Result> Result;
		};
		///     ()     i.  i<0  i > Length<IList>::value,      ERROR__Index_out_of_IndexList_range.
		template<int i,class IList> 
		struct EraseAt;

		template<int i> 
		struct EraseAt<i,Loki::NullType >
		{ 
			enum { value = ERROR__Index_out_of_IndexList_range<i>::index };
			typedef typename Loki::NullType Result;
		};
		template<int j,class T> 
		struct EraseAt<0,IndexList<j,T> >
		{  
			typedef T Result; 
		};
		template<int i,int j,class T> 
		struct EraseAt<i,IndexList<j,T> >
		{
			typedef IndexList<j,typename EraseAt<i-1,T>::Result> Result;
		};
		///     v   IList.
		template<int v,class IList> struct Count;
		template<int v> struct Count<v,Loki::NullType>
		{
			enum { value=0};
		};
		template<int v,int i,class Tail> struct Count<v,IndexList<i,Tail> >
		{
			enum { value=((i==v)?1:0)+Count<v,Tail>::value };
		};
		///     i-    v    IList.
		template<int v,int i,class IList> struct ICount;
		template<int v,int j,class T> struct ICount<v,0,IndexList<j,T> >
		{
			enum { value=0 };
		};
		template<int v,int i,int j,class T> struct ICount<v,i,IndexList<j,T> >
		{
			enum { value=((v==j)?1:0)+ICount<v,i-1,T>::value };
		};
		template<int v,int i> struct ICount<v,i,Loki::NullType >
		{
			enum { value=ERROR__Index_out_of_IndexList_range<i>::index };
		};



		template<class IList> 
		struct Debug;
		template<int i,class Tail> 
		struct Debug<IndexList<i,Tail> >
		{
			static void print(std::ostream& os)
			{
				os<< i << ", ";
				Debug<Tail>::print(os);
			}
		};
		template<int i> 
		struct Debug<IndexList<i,Loki::NullType> >
		{
			static void print(std::ostream& os)
			{
				os<< i ;
			}
		};
		template<> 
		struct Debug<Loki::NullType >
		{
			static void print(std::ostream& os)
			{
			}
		};
		template<class T> T type2ostream() {T t; return t;}
	}//namespace IL
}//namespace Meta
}//namespace Vtl
///          . 
///          ,    
///      ,     "".
template<int i,class Tail>
std::ostream& operator<<(std::ostream& os, typename Vtl::Meta::IndexList<i,Tail> )
{
	os<< "type IndexList: Length=" << Vtl::Meta::IL::Length<Vtl::Meta::IndexList<i,Tail> >::value << ",  Elems = { ";
	Vtl::Meta::IL::Debug<Vtl::Meta::IndexList<i,Tail> >::print(os);
	os<< " }" ;
	return os;
}

#endif //_VTL_META_INDEXLIST_H
