#ifndef _NUMALG_H 
#define _NUMALG_H 
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <cmath>
#include <assert.h>
#include "loki_TypeManip.h"
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
namespace Vtl
{
/// \brief     
namespace NumAlg
{
	/// FORTRAN definition: if (x2 >= 0) returns  std::abs(x1) else returns -std::abs(x1);
	/// ..              .
	template<typename T1,typename T2>	T1 sign(T1 x1,T2 x2) { return (x2 >= 0) ? std::abs(x1) : -std::abs(x1); }
	//      T (  )
	template<typename T>
	T RelerrEps()
	{
		T eps=T(1);
		{
		    T tol;
			do
			{
				eps=eps/T(2);
				tol=T(1)+eps;
			} while(tol > T(1));
		}
		return eps;
	}
} //namespace NumAlg
} //namespace Vtl
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif //_NUMALG_H 
