#ifndef __NUMMET_H__
#define __NUMMET_H__
//////////////////////////////////////////////////////////////////
#include "ytypes.h"
/** @defgroup NumericalMethodsDoxGroup  Numerical calculations
 *
 *  @brief   
 *
 *  @{
 */

//#ifndef M_PI
//	#define M_PI 3.1415926
//#endif

////////////////// numeric0.cpp //////////////////////////
/// !!! n - ,    =(n+1)   !!!!!
double nmPoly(double x,const double *coef,int n);
int nmPow(int a,int b);//!>  a**b
///     .  - 8 .
/// @par FUN(x,void *param) -  
/// @par A -    
/// @par B -    
/// @par param -         
///
/// :\n
/// ., ., ..    .
/// . . 1980.  280 . .  . ...
///
/// :\n
/// Prentice-hall, inc.
/// Englrwood clifs, N.J. 07632
/// 1977
double nmQUANC8(double (*FUN)(double,void *),const double A,const double B,
		void *param,const double ABSERR,const double RELERR,
		double& ERREST,int& NOFUN,double& FLAG);
///    1  \c X   \c [AX,BX].
/// . \ref Lit_Forsythe80
double nmFMIN(double (*FUN)(double,void *),double AX,double BX,void *param,double TOL);
///    1  \c X   \c [AX,BX] (  f(x)=0).
/// . \ref Lit_Forsythe80
double nmZEROIN(double (*FUN)(double,void *),double AX,double BX,void *param,double TOL);
///    ,   -  .
/// . \ref Lit_Forsythe80
void   nmSPLINE_FREE(int n,const double *x,const double *y,double *b,double *c,double *d);
///    ,   -   .
/// . \ref Lit_Forsythe80
void   nmSPLINE(int n,const double *x,const double *y,double *b,double *c,double *d);
///        
/// nmSPLINE_FREE  nmSPLINE
/// . \ref Lit_Forsythe80
double nmSEVAL(int n,double u,const double *x,const double *y,const double *b,const double *c,const double *d);
///  ln((x))
/// . \ref Lit_NRC2
double nmGAMMLN(double xx);
///    .
/// . \ref Lit_Forsythe80
int    nmSVD(int NM,int M,int N,double *A,double *W,double *U,double *V,double *RV1);
///   N   ,    IMSL
int    nmVDCPS(int N,int *IPF,int *IEXP,int *IPWR); 
///       ,    IMSL
void   nmVTRAN(double *A,int N,int M); 
///     
template<class T> T nmMaxArrayElem(int n,const T* array);
////////////////// tstudent.cpp //////////////////////////
/// 0<p<=0.5
double nmNormQRev(double p); 
///  B(1/2,n/2)==(1/2)(n/2)/((n+1)/2)
double nmBetaFnForStudent(double n); 
///    
///    n>=1; 0<p<1
double nmTStudentPercPtNlRoot(double p,int n);
double nmTStudentPercPtAssimpt(double p,int n);
double nmTStudentPercPt(double p,int n);
double nmTStudentPercPtViaIntegral(double p,double n);
double nmTStudentPercPtTauThreshold(double p,int n);// 0<p<1 , n>=3
//////////////////////////////////////////////////////////////////
template <class T>          T      nmRang(int k,T * a,int n);
template <class T>          T      nmMedian(T * a,int n);
template <class T>          void   nmMedian1D(T* data,int n,int half_wnd_size,T* buf,bool reflect_edjes=false); //buf[2*(half_wnd_size*2+1)]
template <class T,class TT> void   nmLinearLeastSquares(int n,const T *x,const TT *y,double &slope,double& intercept);
template <class T>          int    nmFindBadByStudent(int n,const T* array,const double* tau2,double* mean,double* disp2);
template <class T>          double nmMeanAndDisp(int n,const T* array,double *dispsqr=0);
template <class T,class TT> int    nmFindBadByStudent(int n,const T* x,const TT* y,const double* tau2);
template <class T>          double nmFilteredMeanByStudent(int n,T* array,const double* tau2,int* n_rest=0);
// include templates bodies
#include "nummet00.h"
/** @} */ // end of NumericalMethodsDoxGroup
//////////////////////////////////////////////////////////////////
#endif //__NUMMET_H__
